*ON SHUTDOWN QUIT
PUBLIC gcMessages, ofrmMain
m.gcMessages = ""
m.ofrmMain = CREATEOBJECT ("frmMain")
m.ofrmMain.Show (1)
READ EVENTS
ON SHUTDOWN
*QUIT

DEFINE CLASS frmMain AS Form

 Height = 300
 Width = 300
 ShowWindow = 2
 AutoCenter = .T.
 BorderStyle = 2
 Caption = "Server window"
 MaxButton = .F.
 MinButton = .F.
 WindowType = 1
 Name = "frmMain"

 ADD OBJECT cmdSend AS CommandButton WITH ;
  AutoSize = .T., ;
  Caption = "Send Message", ;
  Name = "cmdSend"

 ADD OBJECT cmdClose AS CommandButton WITH ;
  Left = 200, ;
  AutoSize = .T., ;
  Caption = "Close", ;
  Name = "cmdClose"

 ADD OBJECT cntSockets AS Container WITH ;
  Name = "cntSockets", ;
  Visible = .F.

 ADD OBJECT edtMessages AS EditBox WITH ;
  Top = 30, ;
  Height = 270, ;
  Width = 300, ;
  ControlSource = "m.gcMessages", ;
  Name = "edtMessages"

 ADD OBJECT oleDispatcher AS oleSocket WITH ;
  Name = "oleDispatcher"

 PROCEDURE Unload
  CLEAR EVENTS
 ENDPROC

 PROCEDURE Init
  Application.AutoYield = .F.
  ThisForm.oleDispatcher.Object.LocalPort = 9999
  ThisForm.oleDispatcher.Object.Listen ()
  m.gcMessages = m.gcMessages + CHR (13) + CHR (10) + "Server is waiting for connections"
  ThisForm.Refresh ()
 ENDPROC

 PROCEDURE QueryUnload
  ThisForm.oleDispatcher.Close ()
 ENDPROC

 PROCEDURE cmdSend.Click
  FOR EACH oSocket IN ThisForm.cntSockets.Objects
   IF oSocket.Object.State = 7 && Connected
    oSocket.Object.SendData ("Hello from server")
   ENDIF
  ENDFOR
 ENDPROC

 PROCEDURE cmdClose.Click
  ThisForm.Release ()
 ENDPROC

 PROCEDURE oleDispatcher.ConnectionRequest
  LPARAMETERS nRequestID
  LOCAL lcObjectName
  m.lcObjectName = SYS (2015)
  ThisForm.cntSockets.NewObject (m.lcObjectName, "oleServerSocket")
  m.lcObjectName = "ThisForm.cntSockets." + m.lcObjectName
  IF &lcObjectName..Object.State <> 0 && Closed
   &lcObjectName..Object.Close ()
  ENDIF
  &lcObjectName..Object.Accept (m.nRequestID)
  m.gcMessages = m.gcMessages + CHR (13) + CHR (10) + "Client has been connected"
  ThisForm.Refresh ()
 ENDPROC
ENDDEFINE

*-- OLEObject = MSWINSCK.OCX
DEFINE CLASS oleSocket AS OleControl
 Name = "oleSocket"
 OleClass = "MSWinsock.Winsock.1"
 PROCEDURE Destroy
  IF This.Object.State <> 0 && Closed
   This.Object.Close ()
  ENDIF
 ENDPROC
 PROCEDURE Close
  * Note that we must call Close method from within Close event
  * to correctly close a connection
  This.Object.Close ()
 ENDPROC
ENDDEFINE

DEFINE CLASS oleServerSocket AS oleSocket
 Name = "oleServerSocket"
 PROCEDURE DataArrival
  LPARAMETERS tnBytesTotal
  LOCAL lcBuffer
  m.lcBuffer = REPLICATE (" ", m.tnBytesTotal)
  This.Object.GetData (@m.lcBuffer)
  m.gcMessages = m.gcMessages + CHR (13) + CHR (10) + m.lcBuffer
  ThisForm.Refresh ()
 ENDPROC
 PROCEDURE Close
  DODEFAULT ()
  m.gcMessages = m.gcMessages + CHR (13) + CHR (10) + "Client has been disconnected"
  ThisForm.Refresh ()
 ENDPROC
ENDDEFINE
